
cache_J(l, m) = [triv(l), eps(l), vector(m+1, i, J(i-1,l)), l];

biloo_cache(p, q, caJ) = (p[1]*q[1]+p[2]*q[2])*caJ[1]\
  +(p[1]*q[2]+p[2]*q[1])*caJ[2] + (p[1]+p[2])*sum(i=3,#q,caJ[3][q[i]+1])\
  +(q[1]+q[2])*sum(i=3, #p, caJ[3][p[i]+1])\
  +sum(i=3, #p, sum(j=3, #q, caJ[3][p[i]+q[j]+1]+caJ[3][abs(p[i]-q[j])+1]));

epsil(p,q) = I^(p[1]*q[2] + p[2]*q[1] +(p[1]+p[2])*sum(i=3,#q,q[i]+1)\
  +(q[1]+q[2])*sum(i=3, #p, p[i]+1)\
  +sum(i=3, #p, sum(j=3, #q, 2*max(p[i],q[j])+2)));

ex_poids_connus() = [\
  [[1,0], 1], [[0,0,11], 1], [[0,0,15], 1], [[0,0,17], 1],\
  [[0,0,19], 1], [[0,0,21], 1], [[0,1,22], 1], [[0,0,23], 2],\
  [[0,0,7,19], 1], [[0,0,5,21], 1], [[0,0,9,21], 1], [[0,0,13,21], 1],\
  [[0,0,7,23], 1], [[0,0,9,23], 1], [[0,0,13,23], 1],\
  [[0,0,5,13,23], 1], [[0,0,3,15,23], 1], [[0,0,7,15,23], 1],\
  [[0,0,5,17,23], 1], [[0,0,9,17,23], 1], [[0,0,3,19,23], 1],\
  [[0,0,11,19,23], 1], [[0,0,3,11,17,21,23], 1],\
  [[0,1,8,16,24], 1], [[0,0,4,10,18,24], 1], [[0,0,2,14,20,24], 1]\
  ];

is_effective(v) = {
  if(#v<1, return(1));
  if(v[1]==0, return(0));
  for(i=2, #v,
    if(v[i]*v[1]<=0, return(0));
  );
  return(1);
};

veclast(v) = v[#v];

dimw(p) = p[1]+p[2]+2*(#p-2);

init_testfin(l, poids_connus) = {
  my(gra, caJ);
  caJ = cache_J(l, 300);
  gra = matrix(#poids_connus, #poids_connus, i, j,\
    if(i==j, 1/poids_connus[i][2])\
    +((epsil(poids_connus[i][1],poids_connus[j][1])-1)/4*Phi12(l)\
      -biloo_cache(poids_connus[i][1], poids_connus[j][1], caJ))/Phi0(l));
  return([l, caJ, poids_connus, gra]);
};

bil_contre_connus(p, ca, autodual=0) = {
  vector(#ca[3], i,\
    (if(autodual, (epsil(ca[3][i][1], p)-1)/4*Phi12(ca[1]))\
    -biloo_cache(ca[3][i][1], p, ca[2]))/Phi0(ca[1]));
};

testfin(p, mult, ca, verbose=0, min_card=1, max_card=-1) = {
  my(l, caJ, poids_connus, gra11, gra21, gra22, gra, E, V,\
    min_eig, min_poids, min_vec, mask, card, i, n);
  [l, caJ, poids_connus, gra11] = ca;
  gra21 = bil_contre_connus(p, ca, mult==1);
  gra22 = matrix(1, 1, i, j, 1/mult -biloo_cache(p, p, caJ)/Phi0(l));
  min_eig = gra22[1,1];
  min_poids = [];
  min_vec = [1];
  min_mask = 0;
  n = #poids_connus;
  mask = (1<<min_card) - 1;
  card = min_card;
  while(card<=n && card!=max_card+1,
    gra = matconcat([vecextract(gra11, mask, mask), vecextract(gra21, mask)~;\
                     vecextract(gra21, mask), gra22]);
    [E, V] = qfjacobi(gra);
    if(E[1]<min_eig && is_effective(V[,1]),
      min_poids = vecextract(poids_connus, mask);
      min_vec = V[,1];
      min_eig = E[1];
      min_mask = mask;
      if(verbose>0,
        print("new min:", min_poids, "; ", min_vec~, "; ", min_eig);
      );
    );
    i = n-1;
    while(bittest(mask, i), i--); \\ trouve le premier 0 en partant de la gauche
    j = i-1;
    while(j>=0 && !bittest(mask, j), j--); \\ trouve le premier 1 suivant
    if(j<0,
      card++;
      mask = (1<<card) - 1;
      if(verbose && card<=n && card!=max_card+1, print("card=", card));
    ,
      mask = bitor(bitand(mask, ((1<<j) - 1)), ((1<<(n-i)) - 1) << (j+1));
    );
  );
  return([min_eig, min_poids, min_vec~, min_mask]);
};

testfin_liste(wts, l, mult, poids_connus, min_card=1, max_card=-1, prox=-1) = {
  my(ca, count_calc, count_new, count_rem, count_killed, eig, poids, vec, mask,\
     res);
  count_calc = 0;
  count_rem = 0;
  count_new = 0;
  count_killed = 0;
  res = vector(#wts);
  ca = init_testfin(l, poids_connus);
  for(u=1, #wts,
    if(prox<0 || abs(wts[u][2]-l)<prox+.00001,
      count_calc += 1;
      [eig, poids, vec, mask] =\
        testfin(wts[u][1], mult, ca, verbose=0, min_card, max_card);
      if(eig<wts[u][3],
        count_new += 1;
        if(eig<=-0.001 && wts[u][3]>-0.001,
          count_killed += 1;
        );
        res[u] = [wts[u][1], l, eig, mask, vec];
      ,
        res[u] = wts[u];
      );
    ,
      res[u] = wts[u];
    );
    if(res[u][3]>-0.001, count_rem += 1);
  );
  if(count_calc>0,
    print("l=", l, ", ", count_new, " new, ", count_killed, " killed, ",\
          count_rem, " remaining.");
  );
  return(res);
};

testfin_double(weights, ca, verbose=0, min_card=1, max_card=-1) = {
  my(l, caJ, poids_connus, gra11, gra21, gra22, gra, E, V,\
    min_eig, min_poids, min_vec, mask, card, i, n, p1, mult1, p2, mult2);
  [p1, mult1, p2, mult2] = weights;
  [l, caJ, poids_connus, gra11] = ca;
  gra21 = matconcat([bil_contre_connus(p1, ca, mult1==1);\
                     bil_contre_connus(p2, ca, mult2==1)]);
  gra22 = matrix(2, 2);
  gra22[1,1] = 1/mult1 -biloo_cache(p1, p1, caJ)/Phi0(l);
  gra22[2,2] = 1/mult2 -biloo_cache(p2, p2, caJ)/Phi0(l);
  gra22[1,2] = (if(mult1==1 && mult2==1, (epsil(p1, p2)-1)/4*Phi12(l))\
                -biloo_cache(p1, p2, caJ))/Phi0(l);
  gra22[2,1] = gra22[1,2];
  min_eig = gra22[1,1];
  min_vec = [1, 0];
  if(gra22[2,2]<min_eig,
    min_eig = gra22[2,2];
    min_vec = [0, 1];
  );
  [E, V] = qfjacobi(gra22);
  if(E[1]<min_eig && is_effective(V[,1]),
    min_eig = E[1];
    min_vec = V[,1];
  );
  min_poids = [];
  min_mask = 0;
  n = #poids_connus;
  mask = (1<<min_card) - 1;
  card = min_card;
  while(card<=n && card!=max_card+1,
    gra = matconcat([vecextract(gra11, mask, mask), vecextract(gra21, mask)~;\
                     vecextract(gra21, mask), gra22]);
    [E, V] = qfjacobi(gra);
    if(E[1]<min_eig && is_effective(V[,1]),
      min_poids = vecextract(poids_connus, mask);
      min_vec = V[,1];
      min_eig = E[1];
      min_mask = mask;
      if(verbose>0,
        print("new min:", min_poids, "; ", min_vec~, "; ", min_eig);
      );
    );
    i = n-1;
    while(bittest(mask, i), i--); \\ trouve le premier 0 en partant de la gauche
    j = i-1;
    while(j>=0 && !bittest(mask, j), j--); \\ trouve le premier 1 suivant
    if(j<0,
      card++;
      mask = (1<<card) - 1;
      if(verbose && card<=n && card!=max_card+1, print("card=", card));
    ,
      mask = bitor(bitand(mask, ((1<<j) - 1)), ((1<<(n-i)) - 1) << (j+1));
    );
  );
  return([min_eig, min_poids, min_vec~, min_mask]);
};

testfin_double_liste(wts, l, poids_connus, min_card=1, max_card=-1, prox=-1) = {
  my(ca, count_calc, count_new, count_rem, count_killed, eig, poids, vec, mask,\
     res);
  count_calc = 0;
  count_rem = 0;
  count_new = 0;
  count_killed = 0;
  res = vector(#wts);
  ca = init_testfin(l, poids_connus);
  for(u=1, #wts,
    if(prox<0 || abs(wts[u][2]-l)<prox+.00001,
      count_calc += 1;
      [eig, poids, vec, mask] =\
        testfin_double(wts[u][1], ca, verbose=0, min_card, max_card);
      if(eig<wts[u][3],
        count_new += 1;
        if(eig<=-0.001 && wts[u][3]>-0.001,
          count_killed += 1;
        );
        res[u] = [wts[u][1], l, eig, mask, vec];
      ,
        res[u] = wts[u];
      );
    ,
      res[u] = wts[u];
    );
    if(res[u][3]>-0.001, count_rem += 1);
  );
  if(count_calc>0,
    print("l=", l, ", ", count_new, " new, ", count_killed, " killed, ",\
          count_rem, " remaining.");
  );
  return(res);
};
