def chain_gen(A, B):
    for x in A:
        yield x
    for x in B:
        yield x

def ppart(m, p):
    k=0
    x = m
    while Mod(x,p)==0:
        x=x/p
        k=k+1
    return x, k

def load_from_txt(filename):
    res = {}
    with open(filename, "r") as fp:
        s = fp.readline().rstrip()
        while s:
            cc_str, m_str = s.split(':')
            m = QQ(m_str)
            cc = eval(cc_str)
            if cc in res:
                print("Error: cc "+cc_str+" appears twice in "+filename)
                raise ValueError
            res[cc] = m
            s = fp.readline().rstrip()
    return res

def iter_blocks(it, size):
    L = []
    count = 0
    for x in it:
        L.append(x)
        count += 1
        if count==size:
            yield L
            L = []
            count = 0
    if count>0:
        yield L
    return

def set_partitions_2(n, a, whole_set = None):
    if n<=0 or a>n:
        return [[[], [], Mod(0,2)]]
    if whole_set is None:
        whole_set = list(range(1, n+1))
    if a<=0:
        return [[[], whole_set, Mod(0,2)]]
    res = []
    for next_el in range(n-a+1):
        for pa in set_partitions_2(n-next_el-1, a-1, whole_set[next_el+1:]):
            res.append([[whole_set[next_el]]+pa[0], whole_set[:next_el]+pa[1],
                        pa[2]+Mod(a*next_el,2)])
    return res

def it_dw_Sp(n, hodge_mw, sieg_genus, sieg_mw):
    dw = [0]*n
    max_wt = max(hodge_mw-n, sieg_mw-1-n)
    while dw[0]<=max_wt:
        yield tuple(dw)
        i = n-1
        while i>0 and dw[i-1]==dw[i]:
            i -= 1
        dw[i] += 1
        if dw[0]+n<=hodge_mw:
            for j in range(i+1, n):
                dw[j] = 0
        else:
            for j in range(i+1, n):
                dw[j] = max(0, dw[0]-sieg_genus+n)
    return

def it_dw_SO_even(n, hodge_mw, sieg_genus, sieg_mw):
    dw = [0]*n
    max_wt = max(hodge_mw-n+1, sieg_mw-n)
    while dw[0]<=max_wt:
        yield tuple(dw)
        i = n-1
        while i>0 and dw[i-1]==dw[i]:
            i -= 1
        dw[i] += 1
        if dw[0]+n-1<=hodge_mw:
            for j in range(i+1, n):
                dw[j] = 0
        else:
            for j in range(i+1, n):
                dw[j] = max(1, dw[0]-sieg_genus+n)
    return

# enumerates dominant weights corresponding to motivic weight <= 2*hodge_mw-1
# or which can occur in the parameter of a Siegel modular form of genus <=
# sieg_genus and weight <= sieg_mw+1
def it_dw_SO_odd(n, hodge_mw, sieg_genus, sieg_mw):
    dw = [0]*n
    if 2*n<=sieg_genus:
        max_wt = max(hodge_mw-n, sieg_mw-n-1)
    else:
        max_wt = hodge_mw-n
    while dw[0]<=max_wt:
        yield tuple(dw)
        i = n-1
        while i>0 and dw[i-1]==dw[i]:
            i -= 1
        dw[i] += 1
        if dw[0]+n<=hodge_mw:
            for j in range(i+1, n):
                dw[j] = 0
        else:
            for j in range(i+1, n):
                dw[j] = max(1, dw[0]-sieg_genus+n+1)
    return
