# create db from PARI's output

def append_db(db, fn):
    R = RealField(70)
    with open(fn, "r") as fp:
        s = fp.readline().rstrip()
        while s:
            wt_str, l, val, mask, vec_str = s.split(':')
            wt_str_as_list = wt_str.replace(' ', '').replace('[', '')\
                    .replace(']', '').split(',')
            wt = tuple(ZZ(x) for x in wt_str_as_list)
            vec_str_as_list = vec_str.replace(' ', '').replace('[', '')\
                    .replace(']', '').split(',')
            vec = tuple(R(x) for x in vec_str_as_list)
            db[wt] = (R(l), R(val), ZZ(mask), vec)
            s = fp.readline().rstrip()

def write_db(db, fn):
    with open(fn, 'w') as fp:
        for k, L in db.items():
            fp.write(str(list(k))+':'+str(L[0])+':'+str(L[1])+':'+str(L[2])+':'
                     +str(list(L[3] ))+'\n')

def dimw(wt):
    return wt[0]+wt[1]+2*(len(wt)-2)

def wt2dw_SO_even(wt):
    n = len(wt)-2
    if wt[0]==0 and wt[1]==0:
        res = tuple(ZZ(wt[n+1-i]/2)-n+1+i for i in range(n))
    elif wt[0]==1 and wt[1]==1:
        res = tuple(ZZ(wt[n+1-i]/2)-n+i for i in range(n))+(0,)
        n += 1
    else:
        raise ValueError
    if res[n-1]<0 or not all(res[i]>=res[i+1] for i in range(n-1)):
        raise ValueError
    return res

def dw2wt_SO_even(dw):
    n = len(dw)
    if dw[-1]>0:
        return tuple([0,0]+[2*(dw[n-1-i]+i) for i in range(n)])
    return tuple([1,1]+[2*(dw[n-1-i]+i) for i in range(1,n)])

def wt2dw_SO_odd(wt):
    n = len(wt)-2
    res = tuple(ZZ((wt[n+1-i]-1)/2)-n+1+i for i in range(n))
    if res[n-1]<0 or not all(res[i]>=res[i+1] for i in range(n-1)):
        raise ValueError
    return res

def dw2wt_SO_odd(dw):
    n = len(dw)
    return tuple([0,0]+[2*(dw[n-1-i]+i)+1 for i in range(n)])

def wt2dw_Sp(wt):
    if wt[0]+wt[1]!=1:
        raise ValueError
    n = len(wt)-2
    if Mod(n+wt[1],2)!=0:
        raise ValueError
    res = tuple(ZZ(wt[n+1-i]/2)-n+i for i in range(n))
    if res[n-1]<0 or not all(res[i]>=res[i+1] for i in range(n-1)):
        raise ValueError
    return res

def dw2wt_Sp(dw):
    n = len(dw)
    if Mod(n,2)==0:
        return tuple([1,0]+[2*(dw[n-1-i]+i+1) for i in range(n)])
    return tuple([0,1]+[2*(dw[n-1-i]+i+1) for i in range(n)])
